/******************************************************************************/
/*                                                                            */
/*                                                    FILE: TipProcessor.java */
/*                                                                            */
/*       Prints the value of the Tip annotation                               */
/*       ======================================                               */
/*                                                                            */
/*       V1.00    27-JAN-2015  Te                                             */
/*                                                                            */
/******************************************************************************/

package ch.heimetli.tip ;

import java.lang.annotation.* ;
import java.util.* ;
import javax.annotation.processing.* ;
import javax.lang.model.* ;
import javax.lang.model.element.* ;

import pack.Tip ;

/**
 * Prints the value of the Tip annotation.
 *
 * This class is instatiated by javac. The compiler
 * will call process whenever something happens that
 * might be of interest for the annotation processor.
 *
 * Based on AbstractProcessor to keep the code as
 * simple as possible.
 */
@SupportedAnnotationTypes("pack.Tip")
@SupportedSourceVersion(SourceVersion.RELEASE_8)
public class TipProcessor extends AbstractProcessor
{
   public TipProcessor()
   {
      super() ;
   }

   /**
    * Called by javac when it processes something related
    * to annotations
    */
   @Override
   public boolean process( Set<? extends TypeElement> annotations, RoundEnvironment env )
   {
      // Print the value of the Tip annotations
      for( Element element : env.getElementsAnnotatedWith(Tip.class) )
      {
         System.out.println( element.getSimpleName() + " -> " + element.getAnnotation(Tip.class).value() ) ;
      }

      return true ;
   }
}